;special wrappers over two frame buttons
(document:surround "/std/base")

(document:envelop with-translation _ "alterator-standalone")

;;;;;;;;;;;;;;;;;

(define (frame:replace url . args)
  (frame:clear-on-apply)
  (frame:clear-on-leave)
  (frame:clear-buttons-view)
  (apply document:replace-in-widget (global 'frame:page) url args)
  ;;recreate frame:buttons-view here
  (clean-widget (global 'frame:buttons) (lambda() ((global 'frame:buttons) (frame:call-buttons-view)))))

(define (frame:make-page)
  (begin-1 (document:id page-id (document:subdocument '/std/box))
           (page-id layout-policy 100 100)
           (set-global! 'frame:page page-id)))
(define (frame:make-buttons-view  . args)
  (begin-1 (document:id buttons-id (apply hbox args))
           (set-global! 'frame:buttons buttons-id)))

;;;;;;;;;;;;;;;;;;;;;; wizard compatibility
(define (frame:next) 'missing)
(define (frame:back) 'missing)
(define (frame:on-next thunk) 'missing)
(define (frame:on-back thunk) 'missing)

;;;;;;;;;;;;;;;;

(define (frame:on-* name thunk)
  (let ((on-* (global name)))
       (and on-* (cell-set! on-* thunk))))
(define (frame:clear-on-* name)
  (let ((on-* (global name)))
  (if on-*
      (cell-set! on-* #f)
      (set-global! name (make-cell #f)))))
(define (frame:call-on-* name)
  (and-let* ((on-* (global name))
             (on-* (cell-ref on-*)))
       (and (procedure? on-*) (on-*))))

;;;;;;;;;;;;;;;

(define (frame:on-leave thunk)
  (frame:on-* 'frame:leave thunk))
(define (frame:clear-on-leave)
  (frame:clear-on-* 'frame:leave))
(define (frame:call-on-leave)
  (frame:call-on-* 'frame:leave))

(define (frame:on-apply thunk)
  (frame:on-* 'frame:apply thunk))
(define (frame:clear-on-apply)
  (frame:clear-on-* 'frame:apply))
(define (frame:call-on-apply)
  (frame:call-on-* 'frame:apply))

(define (frame:buttons-view . args)
  (frame:on-* 'frame:buttons-helper (thunk args)))
(define (frame:clear-buttons-view)
  (frame:clear-on-* 'frame:buttons-helper))
(define (frame:call-buttons-view)
  (frame:call-on-* 'frame:buttons-helper))

;;;;;;;;;;;;;;;;;;;;;;;
(define (get-source topic)
  (define-operation get-lang)
  (woo-get-option
   (woo-read-first '/help
                   'language (get-lang (fluid-ref generic-session))
                   'topic topic
                   'format "html")
   'source))

(define (frame:help topic)
  (help (get-source topic)))
